//+------------------------------------------------------------------+
//|                                                OILFXMACDv001.mq4 |
//| Original idea by OILFXPRO                                        |
//| Original code from metaquotes                                    |
//| Modify and improve codings by davidke20                          |
//|                        Copyright  2007, http://www.forex-tsd.com|
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, FOREX-TSD"
#property link      "http://www.forex-tsd.com/expert-advisors-metatrader-4/11482-oilfxpro-trendmaster-double-macd-ea-freeversion.html#post174184"

extern int     Magic_number   =  772188;
extern int     Take_Profit    =  700;
extern int     Stop_Loss      =  70;
extern int     TrailingStop   =  70;
extern double  Lots           =  0.1;
extern int     Gap            =  20;
extern int     Slippage       =  3;
extern int     Duration       =  0;
extern string  MACD_Setup;
extern int     Fast_EMA1      =  12;
extern int     Slow_EMA1      =  18;
extern int     Signal1        =  15;
extern double  Trigger1       =  0.0007;
extern int     Fast_EMA2      =  40;
extern int     Slow_EMA2      =  104;
extern int     Signal2        =  36;
extern double  Trigger2       =  0.0000;
extern bool    CloseNReverse  =  false;

int KillDuration=0;
datetime TimeStamp=0;
bool Buy=false,Sell=false;
string EA_name="OILFXMACD";
double TakeProfit,StopLoss;
double OpenOrderPrice;

//+------------------------------------------------------------------+
//| Orders management function                                       |
//+------------------------------------------------------------------+
bool isNewSymbol(string current_symbol)
  {
   //loop through all the opened order and compare the symbols
   int total  = OrdersTotal();
   for(int cnt = 0 ; cnt < total ; cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      string selected_symbol = OrderSymbol();
      if (current_symbol == selected_symbol && OrderMagicNumber()==Magic_number)
      return (False);
    }
    return (True);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int cnt, ticket, total;

   double MACD1=iMACD(NULL,0,Fast_EMA1,Slow_EMA1,Signal1,PRICE_CLOSE,MODE_MAIN,0);
   double MACD2=iMACD(NULL,0,Fast_EMA2,Slow_EMA2,Signal2,PRICE_CLOSE,MODE_MAIN,0);
   
   if(MACD1>Trigger1 && MACD2>Trigger2) {Buy=true;Sell=false;}
   if(MACD1<Trigger1-(Trigger1*2) && MACD2<Trigger2-(Trigger2*2)) {Buy=false;Sell=true;}

   total=OrdersTotal();
   if(total < 1 || isNewSymbol(Symbol()) && TimeStamp!=iTime(NULL,0,0)) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      if(Duration>0)
      {KillDuration=TimeCurrent()+Duration;}
      else
      {KillDuration=0;}
      // check for long position (BUY) possibility
      if(Buy && !Sell)
        {
            OpenOrderPrice=Ask+Gap*Point;
            if(Stop_Loss>5)
               {StopLoss=OpenOrderPrice-Stop_Loss*Point;}
               else
               {StopLoss=0;}
            if(Take_Profit>5)
               {TakeProfit=OpenOrderPrice+Take_Profit*Point;}
               else
               {TakeProfit=0;}
            ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,OpenOrderPrice,Slippage,StopLoss,TakeProfit,EA_name,Magic_number,KillDuration,Blue);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) TimeStamp=iTime(NULL,0,0);
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
      // check for short position (SELL) possibility
      if(Sell && !Buy)
        {
            OpenOrderPrice=Bid-Gap*Point;
            if(Stop_Loss>5)
               {StopLoss=OpenOrderPrice+Stop_Loss*Point;}
               else
               {StopLoss=0;}
            if(Take_Profit>5)
               {TakeProfit=OpenOrderPrice-Take_Profit*Point;}
               else
               {TakeProfit=0;}
            ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,OpenOrderPrice,Slippage,StopLoss,TakeProfit,EA_name,Magic_number,KillDuration,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) TimeStamp=iTime(NULL,0,0);
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol() &&  // check for symbol
         OrderMagicNumber()==Magic_number)
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(Sell && !Buy && CloseNReverse)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Blue); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Yellow);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if(Buy && !Sell && CloseNReverse)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Red); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Yellow);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
// the end.